import { Component, OnInit, ViewChild } from '@angular/core';
import { STComponent, STColumn, STChange } from '@delon/abc/st';
import { SFComponent, SFSchema } from '@delon/form';
import { NzModalService } from 'ng-zorro-antd/modal';
import { SystemService } from '../../services/system.service';
import { SettingRoleEditComponent } from './edit/edit.component';

@Component({
  selector: 'app-role-management',
  templateUrl: './role-management.component.html',
  styleUrls: ['./role-management.component.less']
})
export class RoleManagementComponent implements OnInit {
  @ViewChild('st', { static: true })
  st!: STComponent;
  @ViewChild('sf', { static: false })
  sf!: SFComponent;

  url = `/rule?_allow_anonymous=true`;

  searchSchema: SFSchema = {
    properties: {
      receiveName: {
        type: 'string',
        title: '角色名称',
        ui: { placeholder: '请输入' }
      }
    }
  };

  columns: STColumn[] = [
    { title: '角色名称', index: 'no' },
    { title: '角色描述', index: 'description' },
    { title: '创建人手机号', index: 'description' },
    {
      title: '创建时间',
      index: 'updatedAt',
      type: 'date'
    },
    {
      title: '操作',
      buttons: [
        {
          text: '编辑',
          click: item => this.roleAction(item)
        },
        {
          text: '删除',
          click: item => this.deleteAction(item)
        }
      ]
    }
  ];

  selectedRows: any[] = [];

  reqParams = { pageIndex: 1, pageSize: 10 };

  constructor(public service: SystemService, private nzModalService: NzModalService) {}

  ngOnInit(): void {}

  stChange(e: STChange): void {
    switch (e.type) {
      case 'checkbox':
        this.selectedRows = e.checkbox!;
        break;
      case 'filter':
        this.st.load();
        break;
    }
  }

  roleAction(item?: any) {
    const modal = this.nzModalService.create({
      nzContent: SettingRoleEditComponent,
      nzWidth: 900,
      nzComponentParams: item ? { i: { ...item } } : { i: { id: 0 } },
      nzFooter: null
    });
    modal.afterClose.subscribe(res => {
      this.st.load();
    });
  }

  deleteAction(item?: any) {
    this.nzModalService.error({
      nzTitle: '确认删除？',
      nzClosable: false,
      nzCancelText: '取消',
      nzOnOk: () => {}
    });
  }

  /**
   * 重置表单
   */
  resetSF() {
    this.sf.reset();
  }
}
